#include <cstdio>
#include <cassert>
#include <cstring>
#define N 1005
#define BRUT 0
using namespace std;
char L[N][N],ch;
int n,i,j,x[N][N],w[N],h[N],sol,solve(),Brut(int,int,int,int);
int main()
{
    freopen("ssdj.in","r",stdin);
    freopen("ssdj.out","w",stdout);
    scanf("%d",&n);
    assert(n>0);
    assert(n<=1000);
    for(i=1;i<=n;i++)
    {
        scanf("%s",L[i]+1);
        assert(strlen(L[i]+1)==n);
        for(j=1;j<=n;j++)
        {
            assert(L[i][j]>='a'&&L[i][j]<='z');
        }
    }
    if(BRUT)
    {
        int p,q;
        for(i=1;i<=n;i++)
            for(j=1;j<=n;j++)
                for(p=i+1;p<=n;p++)
                    for(q=1;q<=n;q++)
                        sol+=Brut(i,j,p,q);
        printf("%d\n",sol);
        return 0;
    }

    for(ch='b';ch<='z';ch++)
    {
        for(i=1;i<=n;i++)
            for(j=1;j<=n;j++)
            {
                if(L[i][j]<ch)x[i][j]=0;
                else if(L[i][j]==ch)x[i][j]=1;
                else x[i][j]=2;
            }
                //x[i][j]=L[i][j]<ch?0:(L[i][j]==ch?1:2);
        fprintf(stderr, "%c ", ch);
        sol+=solve();
    }
    printf("%d\n",sol);
    return 0;
}
int solve()
{
    int ret=0,st,H,k,i,j;
    for(i=1;i<=n;i++)w[i]=0;
    for(i=1;i<=n;i++)h[i]=1;
    for(i=1;i<=n;i++)
    {
        st=0;
        for(j=1;j<=n;j++)
        {
            h[j]++;
            if(!x[i][j])continue;
            H=h[j];
            if(x[i][j]==1)
            {
                for(k=j-1;k>st;k--)
                {
                    if(!w[k])continue;
                    if(h[k]<H){H=h[k];ret++;}
                }
                w[j]=1;h[j]=1;st=j;
                continue;
            }
            for(k=j-1;k>st;k--)
            {
                if(!w[k])continue;
                if(h[k]<H)
                {
                    H=h[k];
                    if(w[k]==1)ret++;
                }
            }
            w[j]=2;h[j]=1;st=j;
        }
    }

    fprintf(stderr, "%d\n", ret);
    for(i = 1; i <= n; ++i)
        fprintf(stderr, "%d ", h[i]);
    fprintf(stderr, "\n");
    return ret;
}
int Brut(int st,int su,int dr,int jo)
{
    int i,j;
    ch=L[st][su]<L[dr][jo]?L[st][su]:L[dr][jo];
    for(j=st+1;j<=dr;j++)if(L[su][j]>=ch)return 0;
    for(j=st;j<dr;j++)if(L[jo][j]>=ch)return 0;
    for(i=su+1;i<jo;i++)
        for(j=st;j<=dr;j++)
            if(L[i][j]>=ch)return 0;
    return 1;
}
